<template>
  <div>
    <h1 class="title">Ingredients</h1>

    <div class="buttons">
      <router-link v-if="isLoggedIn" :to="{name: 'new_ingredient'}" class="button is-primary">Create Ingredient</router-link>
    </div>

    <app-pager :current-page="currentPage" :total-pages="totalPages" paged-item-name="ingredient" @changePage="changePage"></app-pager>

    <table class="table is-fullwidth is-narrow">
      <thead>
      <tr>
        <th>Name</th>
        <th>USDA</th>
        <th>KCal per 100g</th>
        <th>Density (oz/cup)</th>
        <th></th>
      </tr>
      <tr>
        <th>
          <div class="field">
            <div class="control">
              <input type="text" class="input" placeholder="search names" v-model="search.name">
            </div>
          </div>
        </th>
        <th colspan="4"></th>
      </tr>
      </thead>
      <tbody>
      <tr v-for="i in ingredients" :key="i.id">
        <td><router-link :to="{name: 'ingredient', params: { id: i.id } }">{{i.name}}</router-link></td>
        <td><app-icon v-if="i.usda" icon="check"></app-icon></td>
        <td>{{i.kcal}}</td>
        <td>{{i.density}}</td>
        <td>
          <router-link v-if="isLoggedIn" class="button" :to="{name: 'edit_ingredient', params: { id: i.id } }">
            <app-icon icon="pencil"></app-icon>
          </router-link>
          <button v-if="isLoggedIn" type="button" class="button is-danger">
            <app-icon icon="x"></app-icon>
          </button>
        </td>
      </tr>
      </tbody>
    </table>

    <app-pager :current-page="currentPage" :total-pages="totalPages" paged-item-name="ingredient" @changePage="changePage"></app-pager>

    <div class="buttons">
      <router-link v-if="isLoggedIn" :to="{name: 'new_ingredient'}" class="button is-primary">Create Ingredient</router-link>
    </div>

  </div>
</template>

<script>

  import api from "../lib/Api";
  import debounce from "lodash/debounce";

  export default {
    data() {
      return {
        ingredientData: null,
        search: {
          page: 1,
          per: 25,
          name: null
        }
      };
    },

    computed: {
      ingredients() {
        if (this.ingredientData) {
          return this.ingredientData.ingredients;
        } else {
          return [];
        }
      },

      totalPages() {
        if (this.ingredientData) {
          return this.ingredientData.total_pages
        }
        return 0;
      },

      currentPage() {
        if (this.ingredientData) {
          return this.ingredientData.current_page
        }
        return 0;
      }
    },

    methods: {
      changePage(idx) {
        this.search.page = idx;
      },

      getList: debounce(function() {
        this.loadResource(
          api.getIngredientList(this.search.page, this.search.per, this.search.name)
            .then(data => this.ingredientData = data)
        );
      }, 500, {leading: true, trailing: true})
    },

    created() {
      this.$watch("search",
        () => this.getList(),
        {
          deep: true,
          immediate: true
        }
      );
    },

    components: {
    }
  }

</script>